DATA SEGMENT
    ; 3-8Ӧ˿
    IO2 EQU 220H   ; 8254
    IO4 EQU 240H   ; 8255A 
    
    TIME0      EQU IO2      ; T0ַ
    TIME1      EQU IO2 + 2  ; T1ַ
    TIME_CTR   EQU IO2 + 6  ; 8254ƿڵַ
    
    PORTA EQU IO4          ; 8255 Aڵַ
    PORTB EQU IO4 + 2      ; 8255 Bڵַ
    PORTC EQU IO4 + 4      ; 8255 Cڵַ 
    PORT_CTR  EQU  IO4 + 6 ; 8255 ƿڵַ
    
    I8259_0 EQU 200H	;8259ַ
    I8259_1 EQU 201H

    CNTVAL EQU 1000H ; ֵ
    
    LED DB 3FH,06H,5BH,4FH,66H,6DH,7DH,07H,7FH,6FH
    ;0--9 Ӧѡ룬 
    
    HOU DB 00H ; ʱ 
    MIN DB 00H ;  
    SEC DB 00H ; 
DATA ENDS

SSG SEGMENT STACK
    DW   200  DUP(0)
SSG ENDS

CODE SEGMENT  
    ASSUME CS:CODE,DS:DATA,SS:SSG
    
START: CLI
    ; ݶ
    MOV AX, DATA
    MOV DS, AX
    MOV ES, AX
    
    ; 8259ʼ
    MOV DX,I8259_0
    MOV AL,00010011B;ICW1
    OUT DX,AL
    MOV DX,I8259_1
    MOV AL,00001000B;ICW2
    OUT DX,AL
    MOV AL,00000001B;ICW4
    OUT DX,AL

    PUSH DS
    XOR AX, AX 
    MOV DS, AX
    LEA AX,CS:INT_SERVICE
    MOV SI,08H
    ADD SI,SI
    ADD SI,SI
    
    MOV DS:[SI],AX
    PUSH CS
    POP AX
    MOV DS:[SI+2],AX
    POP DS

    IN AL,DX;OCW1
    AND AL,11111110B
    OUT DX,AL
    STI

    ; ʼ8254
    MOV AL, 00110101B ; T0 д16λ ʽ2 BCD
    MOV DX, TIME_CTR   
    OUT DX, AL
    MOV DX, TIME0        
    MOV AX, CNTVAL    ; 1000Ƶ
    OUT DX, AL
    
    MOV AL, AH        ; ֽ
    OUT DX, AL
    
    MOV AL, 01110111B ; T1 д16λ ʽ3 BCD
    MOV DX, TIME_CTR   
    OUT DX, AL
    MOV DX, TIME1   
    MOV AX, CNTVAL    ; 1000Ƶ
    OUT DX, AL
    
    MOV AL, AH        ; ֽ
    OUT DX, AL   
    
    ; ʼ8255
    MOV AL, 81H ; ABCϲ²
    MOV DX,PORT_CTR
    OUT DX, AL
    
LP:
    ; 
    
    CALL KEY
    CALL DISP    ; ʾӳ
    JMP LP       ; ѭ

INT_SERVICE:
    ; жϷ
    PUSH AX
    MOV AL, SEC
    ADD AL, 1
    DAA          ; УBCDӷ    
    
    MOV SEC, AL
    CMP SEC, 60H
    JB  EXIT      
    MOV SEC, 0
    MOV AL,  MIN
    ADD AL,  1
    DAA
    
    MOV MIN, AL
    CMP MIN, 60H
    JB  EXIT
    MOV MIN, 0
    MOV AL,  HOU
    ADD AL,  1
    DAA
    
    MOV HOU, AL
    CMP HOU, 24H
    JB  EXIT
    MOV HOU, 0
EXIT: 

    MOV DX,I8259_0
    MOV AL,00010011B;ICW1
    OUT DX,AL
    MOV DX,I8259_1
    MOV AL,00001000B;ICW2
    OUT DX,AL
    MOV AL,00000001B;ICW4
    OUT DX,AL

    PUSH DS
    XOR AX, AX 
    MOV DS, AX
    LEA AX,CS:INT_SERVICE
    MOV SI,08H
    ADD SI,SI
    ADD SI,SI
    
    MOV DS:[SI],AX
    PUSH CS
    POP AX
    MOV DS:[SI+2],AX
    POP DS

    IN AL,DX;OCW1
    AND AL,11111110B
    OUT DX,AL
    STI
    POP AX
    IRET       ; жϷ


          
DISP PROC 
     ; ʾӳ  
     MOV AL, 0   ; ʾ
     MOV DX, PORTB
     OUT DX, AL     ; λѡźŽӵ8255APB
     
     ; λ
     MOV AL, 01H   
     MOV DX, PORTB          
     OUT DX, AL     ; λѡ
     
     MOV BL, SEC    ; 8λ
     AND BX, 000FH  
     MOV SI, BX 
     MOV AL, LED[SI]  
     MOV DX, PORTA  
     OUT DX, AL       ; ѡ
     CALL DELAY            
   
     MOV AL, 0   ; Ϊֹصÿʾ֮ǰҪ
     MOV DX, PORTB
     OUT DX, AL       
     
     MOV BL, SEC
     AND BX, 00F0H
     MOV CL, 4
     SHR BX, CL      
     MOV SI, BX
 
     MOV AL, 02H   ; ʮλ
     MOV DX, PORTB          
     OUT DX, AL
             
     MOV AL, LED[SI]  ; 
     MOV DX, PORTA
     OUT DX, AL
     CALL DELAY          
     
     MOV AL, 0   ; ʾ
     MOV DX, PORTB
     OUT DX, AL  
                
     MOV AL, 40H    ; "-"  
     MOV DX, PORTA
     OUT DX, AL
     
     MOV AL, 04H   ; "-"λ
     MOV DX, PORTB
     OUT DX, AL
     CALL DELAY   
     
     MOV AL, 0   ; ʾ
     MOV DX, PORTB
     OUT DX, AL    
     
     MOV BL, MIN
     AND BX, 000FH
     MOV SI, BX
     MOV AL, LED[SI]  ; 
     MOV DX, PORTA
     OUT DX, AL
     
     MOV AL, 08H     ; ָλ
     MOV DX, PORTB
     OUT DX, AL
     CALL DELAY  
                      
     MOV AL, 0     ; ʾ
     MOV DX, PORTB
     OUT DX, AL  
     
     MOV BL, MIN
     AND BX, 00F0H
     MOV CL, 4
     SHR BX, CL       
     MOV SI, BX
     MOV AL, LED[SI]  ;  
     MOV DX, PORTA
     OUT DX, AL
     
     MOV AL, 10H   ; ʮλ
     MOV DX, PORTB          
     OUT DX, AL
     CALL DELAY  
     
     MOV AL, 0   ; ʾ
     MOV DX, PORTB
     OUT DX, AL   
     
     MOV AL, 40H    ; "-"  
     AND DX, PORTA
     OUT DX, AL
     
     MOV AL, 20H   ; "-"λ
     MOV DX, PORTB
     OUT DX, AL
     CALL DELAY 
     
     MOV AL, 0   ; ʾ
     MOV DX, PORTB
     OUT DX, AL    

     MOV BL, HOU
     AND BX, 000FH
     MOV SI, BX
     MOV AL, LED[SI]  ; 
     MOV DX, PORTA
     OUT DX, AL
     
     MOV AL, 40H     ; ʱλ
     MOV DX, PORTB
     OUT DX, AL
     CALL DELAY               
     
     MOV AL, 0     ; ʾ
     MOV DX, PORTB
     OUT DX, AL  
     
     MOV BL, HOU
     AND BX, 00F0H
     MOV CL, 4
     SHR BX, CL       
     MOV SI, BX
     MOV AL, LED[SI]  ;  
     MOV DX, PORTA
     OUT DX, AL  
     
     MOV AL, 80H     ; ʱʮλ
     MOV DX, PORTB
     OUT DX, AL
     CALL DELAY
     
     RET              ; ӳ򷵻
DISP ENDP
          
KEY   PROC
    MOV DX, PORTC
    IN AL, DX
    TEST AL, 8H
    JZ NEXTHOU 
    TEST AL, 4H     
    JZ NEXTMIN
    TEST AL, 2H      
    JZ NEXTSEC
    TEST AL, 1H
    JZ RESET
    CALL DISP       ; 
    CALL DISP 
    CALL DISP
    MOV DX, PORTC
    IN AL, DX
    TEST AL, 8H
    JZ NEXTHOU 
    TEST AL, 4H
    JZ NEXTMIN
    TEST AL, 2H
    JZ NEXTSEC
    TEST AL, 1H
    JZ RESET

NEXTHOU: 
   CALL NEXTHOU_0
   JNZ EXITKEY
NEXTMIN: 
   CALL NEXTMIN_0
   JNZ EXITKEY
NEXTSEC: 
   CALL NEXTSEC_0
   JNZ EXITKEY
RESET: 
   CALL RESET_0
   JNZ EXITKEY  
EXITKEY:
    RET
    
KEY ENDP

NEXTHOU_0 PROC 
    ; ʱ
    MOV DX, PORTC
    IN AL, DX
    TEST AL, 8H
    JNZ EXITKEY_1  
    CALL DISP
    CALL DISP
    CALL DISP
    MOV DX, PORTC
    IN AL, DX
    TEST AL, 8H
    JNZ EXITKEY_1
    MOV AL, HOU
    ADD AL, 1     
    DAA 
    CALL DELAY   
    
    MOV HOU, AL
    CMP HOU, 24H
    JB NEXTHOU
    MOV HOU, 0
EXITKEY_1:
    RET
NEXTHOU_0 ENDP

NEXTMIN_0 PROC 
    ; ֵ
    MOV DX, PORTC
    IN AL, DX
    TEST AL, 4H
    JNZ EXITKEY_2  
    CALL DISP
    CALL DISP
    CALL DISP
    MOV DX, PORTC
    IN AL, DX
    TEST AL, 4H
    JNZ EXITKEY_2
    MOV AL, MIN
    ADD AL, 1
    DAA      
    CALL DELAY 
    
    MOV MIN, AL
    CMP MIN, 60H
    JB NEXTMIN_1
    MOV MIN, 0
EXITKEY_2:
    RET
NEXTMIN_1:
    CALL NEXTMIN_0    
NEXTMIN_0 ENDP

NEXTSEC_0 PROC
    ; 
    MOV DX, PORTC
    IN AL, DX
    TEST AL, 2H
    JNZ EXITKEY_3  
    CALL DISP
    CALL DISP
    CALL DISP
    MOV DX, PORTC
    IN AL, DX
    TEST AL, 2H
    JNZ EXITKEY_3
    MOV AL, SEC
    ADD AL, 1
    DAA         
    CALL DELAY        
    MOV SEC, AL
    CMP SEC, 60H
    JB NEXTSEC_1
    MOV SEC, 0
EXITKEY_3:
    RET
NEXTSEC_1:
    CALL NEXTSEC_0
NEXTSEC_0 ENDP

RESET_0 PROC
    ; 
    MOV DX, PORTC
    IN AL, DX
    TEST AL, 1H
    JNZ EXITKEY_4  
    CALL DISP
    CALL DISP
    CALL DISP
    MOV DX, PORTC
    IN AL, DX
    TEST AL, 1H
    JNZ EXITKEY_4    
    MOV HOU, 0
    MOV MIN, 0
    MOV SEC, 0
    CALL DELAY
EXITKEY_4:
    RET
RESET_0 ENDP

DELAY PROC
      ; ʱӳ 
      PUSH BX
      PUSH CX
      MOV BX, 1
LP1:  MOV CX, 300
LP2:  LOOP LP2
      DEC BX
      JNZ LP1
      POP CX
      POP BX   
      RET    
DELAY ENDP
               
CODE ENDS

END START 